// router routine tester
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <math.h>
//#include <c:\files\prog\c\rionl.c>
#include <c:\files\prog\c\tio.c>
#include "dstuff.h"

#define  sqr(x) ((x)*(x))

/*  origional syntax
1     turn dremel on
0     turn dremel off
X #   goto x loc.
Y #   goto y loc.
Z #   goto z loc.
S #   set speed.
L #   (x1)  line xy-xy
  #   (y1)
  #   (x2)
  #   (y2)
C #   (xc)  circle
  #   (yc)
  #   (r)
A #   (xc)   arc
  #   (yc)
  #   (r)
  #   (start angle)
  #   (arc angle)
D #  delay (ms)
B 'message'   beep
W 'message'   beep, wait for keyhit
E  end of file
*/

/* ===  new syntax ==

1     turn dremel on
0     turn dremel off
X #   goto x loc.
Y #   goto y loc.
Z #   goto z loc.
S #   set speed.
L #   (x2)  line from current to x2 y2
  #   (y2)
C #   (xc)  circle with xc, yc the centre co-ords, curr position defines radius
  #   (yc)
A #   (xc)   arc Xc, yc = centre, curr position defines radius
  #   (yc)
  #   (arc angle) angle from current position (+ = ccw)
D #  delay (ms)
B 'message'   beep
W 'message'   beep, wait for keyhit
E  end of file

all units in inches

*/


void  cutline(long int x1, long int y1, long int x2, long int y2, long int *stats);
void  cutcircle(long int t1, long int t2, long int t3, long int *stats);
//void  cutarc(long int xc, long int yc, long int r, long int angle_start, long int angle_through, long int *stats);
void cutarc(long int xc, long int yc, long int r, double angle_start, double angle_through, long int *stats);
float angle (float x, float y);

int main(int argc, char** argv)
{
 long int x, y, z, error;
 long int stats[10];
 FILE *input;
 char temp[50];
 char *tmp;
 int end;
 long int line = 0;
 long unsigned int t1, t2, t3, t4;
 double dt1, dt2, dt3;

 speed = 1;  // posotioning speed

 for (x=0; x<11; x++)        // initialize stats
   stats[x] = 0;
 dremeloff();
 setcmode('p');

  if (argc < 2)                           // check input variables
  {

    puts("Syntax: cncit [file] ");
   // printf("Input FileName: ");
   // if (gets
    return 0;

  }

  if ((input = fopen(argv[1], "rt")) == NULL)       //open tga file w err chk
  {

    printf("Unable to open %s for input.", argv[1]);
    return -1;

  }


clrscr();

printf ("CNCit version 3.2\n");

printf ("Zeroing axies...\n");
zero ('*', 'z', stats);      //zero up
dremeloff();

if (!presetMenu(stats)) {
 printf("User abort\n");
 relax();
 return 0;
}

x = 0;  // init stuff
y = 0;
z = 0;

dremelon();
error = 0;
end   = 0;


while ((!error) && (!end))
{
 line++;
 if (fgets ( temp, 40, input ) == NULL)
   end = 1 ;
 strupr ( temp );
// // kill initial whitespace
// while strchr(" \t", temp[0]) {
// !!!???!!!
// }

 /*
 printf(" at: %f %f %f\n",
       (float)x / 14400.0,
       (float)y / 19200.0,
       (float)z / 16000.0
     );

 printf(" stats: %f %f %f\n",
       (float)stats[1] / 14400.0,
       (float)stats[3] / 19200.0,
       (float)stats[5] / 16000.0
     );
 */


 if (temp[0] == '1')
  {
   dremelon();
   printf ("%ld cutter on. \n", line);
   temp[0] = '\0';
  }

 if (temp[0] == '0')
  {
   printf ("%ld cutter off. \n", line);
   dremeloff();
   temp[0] = '\0';
  }

 if (temp[0] == 'X')        // goto x (absolute)
  {
   x = (long)(14400.0 * atof(&temp[strchr(temp, ' ')-temp]));
   printf("%ld X: %.3f\n",line, (float)((float)x / 14400.0 ));
   error = position(x, y, z, stats);
   temp[0] = '\0';
  }

   if (temp[0] == 'Y')      // goto y (absolute)
  {
   y = (unsigned long) (19200.0 * atof(&temp[strchr(temp, ' ')-temp]));
   printf("%ld Y: %.3f\n",line , (float)((float)y / 19200.0));
   error = position(x, y, z, stats);
   temp[0] = '\0';
  }

   if (temp[0] == 'Z')     // goto  z (absolute)
  {
   z = (unsigned long)(16000 * atof(&temp[strchr(temp, ' ')-temp]));
   printf("%ld Z: %.3f\n",line , (float)((float) z / 16000.0) );
   error = position (x, y, z, stats);
   temp[0] = '\0';
  }

    if (temp[0] == 'S')  // set speed
  {
   speed = atoi(&temp[strchr(temp, ' ')-temp]);
   printf("%ld speed: %d\n",line, speed);
   temp[0] = '\0';
  }


    if (temp[0] == 'L')  // ------------ line -------------
  {
     // x2 position
     t1 = (unsigned long)(14400.0 * atof(&temp[strchr(temp,' ')-temp]));
     if (fgets ( temp, 40, input ) == NULL)
	{
	  end = 1 ;
	  continue;
	}
     // y2 position
     t2 = (unsigned long)(19200.0 * atof(&temp[strchr(temp,' ')-temp]));

     printf("%ld line: %.3f,%.3f -> %.3f,%.3f\n",
      line,
      (float)x / 14400,
      (float)y / 19200,
      (float)t1 / 14400,
      (float)t2 / 19200
      );

     cutline(x, y, t1, t2, stats);
     //x = t1;                 // we were left where we are
     //y = t2;
     x = stats[1];                 // we were left where we are
     y = stats[3];


     temp[0] = '\0';
  } // end of 'L' case




    if (temp[0] == 'C')  // ------------------ circle -------------
  {
     t1 = (unsigned long)(14400.0 * atof(&temp[1]));  // x
     if (fgets ( temp, 40, input ) == NULL)
	{
	  end = 1 ;
	  continue;
	}
     line++;

     t2 = (unsigned long)(19200.0 * atof(&temp[1]));     //y

     // work out radius
     t3 = (unsigned long) (4800.0 * sqrt(
		   sqr( ((float)x/14400.0) - ((float)t1/14400.0) ) +
		   sqr( ((float)y/19200.0) - ((float)t2/19200.0) )
		 ));

     // work out current angle
     dt2 = angle(
	( ((float)x/14400.0) - ((float)t1/14400.0) ),
	( ((float)y/19200.0) - ((float)t2/19200.0) )
	);

     printf("%ld circle: cen:%.3f,%.3f rad:%.3f\n",line,
       (float)t1 / 14400.0,
       (float)t2 / 19200.0,
       (float)t3 / 4800.0
     );

     // this should use cutarc and stop at orig position
     //cutcircle(t1, t2, t3, stats);
     cutarc(t1, t2, t3, dt2, 360, stats);

     x = stats[1];                 // we were left where we are
     y = stats[3];

     temp[0] = '\0';
  }



      if (temp[0] == 'A')  // ------------- arc ---------------
  {
    t1 = (unsigned long) (14400.0 * atof(&temp[1]));  // x
     if (fgets ( temp, 40, input ) == NULL)
	{
	  end = 1 ;
	  continue;
	}
     strupr ( temp );
     t2 = (unsigned long)(19200.0 * atof(&temp[1]));     //y
	  if (fgets ( temp, 40, input ) == NULL)
	{
	  end = 1 ;
	  continue;
	}
     strupr ( temp );
     dt3 = atof(&temp[1]);     // angle


     // work out radius
     dt1 = 4800 * sqrt(
		   sqr( ((float)x/14400.0) - ((float)t1/14400.0) ) +
		   sqr( ((float)y/19200.0) - ((float)t2/19200.0) )
		 );

     // work out current angle
     dt2 = angle(
	( ((float)x/14400.0) - ((float)t1/14400.0) ),
	( ((float)y/19200.0) - ((float)t2/19200.0) )
	);


     printf("%ld arc: cen:%.3f,%.3f ang:%.3f rad:%.3f \n",
       line,
       ((float)t1 / 14400.0),
       ((float)t2 / 19200.0),
       dt3,
       ((float)dt1 / 4800.0)
       );

     //cutarc(t1, t2, dt1, dt2, dt2+dt3, stats);
     cutarc(t1, t2, dt1, dt2, dt3, stats);
     x = stats[1];                 // we were left where we are
     y = stats[3];
     temp[0] = '\0';
  }


    if (temp[0] == 'D')
  {
   t1 = atoi(&temp[strchr(temp, ' ')-temp]);
   printf("%ld delay: %lu\n",line, t1);
   delay(t1);
   temp[0] = '\0';
  }

      if (temp[0] == 'B')
  {
   sound(2000);
   delay(100);
   nosound();
   printf("HEY!! %s",&temp[strchr(temp, ' ')-temp]);
   temp[0] = '\0';
  }


	if (temp[0] == 'W')
  {
   sound(1000);
   delay(100);
   nosound();
   printf("HEY!! %s",&temp[strchr(temp, ' ')-temp]);
   while (!kbhit());
   getch();
   temp[0] = '\0';
  }

     if (temp[0] == 'E')
  {
   end = 1;
   printf("end of file\n");
   temp[0] = '\0';
  }

    if (temp[0] != '\0')
     {
       printf("bad command on line %ld \n", line);
       printf(" %s",  temp);
     }

 if (error != 0)
     {
     gotoxy(2,15);
     printf ("error number %ld occured\n", (error & 255));
     }
}

dremeloff();
relax();
return 0;
}





//---- 'complex' routines





void cutline(long int x1, long int y1, long int x2, long int y2, long int *stats)
{


  long int error_term;
  long int length;
  long int i;
  long int y_unit;


  double   slope;
  long int ydiff;
  long int xdiff;
  long int x_unit;
  long int ypos;
/*
  ydiff = y2 - y1;
  xdiff = x2 - x1;


  if (xdiff > 0) {
    x_unit = 1;
  } else {
    x_unit = -1;
  }

  if (xdiff == 0) { // line on Y
    position(x1, y2, stats[5], stats);
  } else if (ydiff == 0) { // line on X
    position(x2, y1, stats[5], stats);
  } else {   // inter axis line
    slope = (float)(y2-y1) / (x2-x1);

    for (i = x1; i!=x2; i+=x_unit) {
     ypos = slope * i;
     position (i, ypos, stats[5], stats);
    }

  }

  return;
  ////////////////////////////////////

  */
//  ****-------  get 4 points for the line -------************


  ydiff = y2 - y1;
  if (ydiff<0)
      {
	ydiff =- ydiff;
	y_unit =- 1;
      }
  else
    y_unit = 1;
   xdiff =x2 - x1;

  if (xdiff<0)
     {
	  xdiff =- xdiff;
	  x_unit =- 1;
      }
  else
    x_unit = 1;

  error_term = 0;

  if (xdiff>ydiff)
    {
     length=xdiff+1;
     for ( i=0; i<length; i++)
       {
	 x1+=x_unit;
	 error_term+=ydiff;
	 if (error_term>xdiff)
	   {
	    error_term-=xdiff;
	    y1+=y_unit;
	   } // end of if
	 position(x1, y1, stats[5], stats);
       } // end of for
  }  // end of if
  else
   {
     length=ydiff+1;
     for ( i=0; i<length; i++)
       {
	 y1+=y_unit;
	 error_term+=xdiff;
	 if (error_term>0)
	    {
	      error_term-=ydiff;
	      x1+=x_unit;
	    } // end of if
	 position(x1, y1, stats[5], stats);
       }// end of for
    }// end of else
 return;

 }




 void cutcircle(long int xc, long int yc, long int r, long int *stats)
   {
    long int x, y, xo, yo;
    double step, inc;


    inc = (double)360/((double)r*(double)4);    // increase detail the larger we go
    step = inc;
    yo = 4 * r * (double)sin(step*(6.2831853/360)) + yc;
    xo = 3 * r * (double)cos(step*(6.2831853/360)) + xc;

    while(step < 360)
     {
      step += inc;
      y = 4 * r * (double)sin(step*(6.2831853/360)) + yc;
      x = 3 * r * (double)cos(step*(6.2831853/360)) + xc;
      cutline(xo, yo, x, y, stats);
      xo = x;
      yo = y;
     }
    return;
   }


   void cutarc(long int xc, long int yc, long int r, double angle_start, double angle_through, long int *stats)
   {
    long int x, y, xo, yo;
    double step, inc, total;


    inc   = (double)360/((double)r*(double)4);    // increase detail the larger we go
    if (angle_through < 0) {
      inc           *= (-1);
      angle_through *= (-1);
    }
    step  = angle_start;
    total = 0;
    yo    = 4 * r * (double)sin(step*(6.2831853/360)) + yc;
    xo    = 3 * r * (double)cos(step*(6.2831853/360)) + xc;

   // printf ("inc: %f through: %f\n", inc, angle_through);

    while(total < angle_through) {

      step  += inc;
      total += fabs(inc);

      //printf ("total: %f end: %f\n", total, angle_through );

      y = 4 * r * (double)sin(step*(6.2831853/360)) + yc;
      x = 3 * r * (double)cos(step*(6.2831853/360)) + xc;

      /*
      printf(" at: %.3f,%.3f going to: %.3f,%.3f\n",
	(float)x  / 14400.0,
	(float)y  / 19200.0,
	(float)xo / 14400.0,
	(float)yo / 19200.0
       );
      */

      cutline(xo, yo, x, y, stats);
      xo = x;
      yo = y;
     }
    return;
   }


float angle (float x, float y) {

 float t, r;

 r = sqrt((x * x) + (y * y));

 t = (180/3.141592654) * asin(y/r);
 if (x > 0) {
   if (y < 0) {
    t = 360 + t;
   }
 }else{
   t = 180 - t;
 }

 return t;
}


int presetMenu(long int *stats) {


/*

 + and - controll speed (step size)
 left and right arrow control X
 up and down arrow control Y
 * and / control Z
 Q to quit
 R to set 0,0,0 and run
 X to input X #
 Y to input Y #
 Z to input z #

*/

 char  command, extended;
 float stepSize;
 double x, y, z;
 char tempc[255];
 float tempf;

 x = y = z = 0;

 command  = '0';
 stepSize = 0.1 ;

 printf(" + and - controll speed (step size) \n\
 left and right arrow control X              \n\
 up and down arrow control Y                 \n\
 * and / control Z                           \n\
 Q to quit                                   \n\
 R to set 0,0,0 and run                      \n\
 X to input X #                              \n\
 Y to input Y #                              \n\
 Z to input z #                              \n");



 while ((command != 'q') & (command != 'r')) {

    while (!kbhit());
      command = getch();

    if (command == 0)
      extended = getch();
    else
      extended = '0';

    switch (command) {

     case '+':
       if (stepSize < 1)
         stepSize *= 2;
   //    printf("Step Size is: %f \r", stepSize);
     break;

     case '-':
       if (stepSize > .001)
         stepSize /= 2;
   //    printf("Step Size is: %f \r", stepSize);
     break;

     case '*':
       z += stepSize;
     break;

     case '/':
       z -= stepSize;
     break;

     case 0: // extended keycode
       switch (extended) {

         case 72:  // up
           y -= stepSize;
         break;

         case 80: // down
           y += stepSize;
         break;

         case 75: // left
           x -= stepSize;
         break;

         case 77: // right
           x += stepSize;
         break;
       }
     break;

     case 'x':
        printf("Enter Relative X Offset: ");
        scanf("%s", &tempc);
        x += atof(tempc);
     break;

     case 'y':
        printf("Enter Relative Y Offset: ");
        scanf("%s", &tempc);
        y += atof(tempc);
     break;

     case 'z':
        printf("Enter Relative Z Offset: ");
        scanf("%s", &tempc);
        z += atof(tempc);
     break;

    } // end of master switch

    position( (long int)(x * 14400.0), (long int)(y * 19200.0), (long int)(z * 16000.0), stats);
    printf(" Step %f @ %f, %f, %f\r", stepSize, x, y, z);

 }   // end of while not quit

  printf("Offset is: %f %f %f\n", x, y, z );

  // bad tweek
  stats[1] = 0;
  stats[3] = 0;
  stats[5] = 0;

 if (command == 'q')
   return 0;
 else
   return 1;

}    // end of function



int presetMenu2(long int *stats) {

  int ok, i1;
  double x_off, y_off, z_off;
  long int speed;
  char mchoice[20];

  ok = 0;

  while(!ok)
   {
  clrscr();
//  printf("  image of %u X %u", width, height);
  gotoxy(1,3);
//  printf("    Size(inches): %.3lf X %.3lf X %.3lf\n\n",t1 ,t2 ,t3);

  printf("1  X Offset:      %f\"\n", x_off);
  printf("2  Y Offset:      %f\"\n", y_off);
  printf("3  Z Offset:      %f\"\n", z_off);
  printf("8  Goto xy offsets\n");
  printf("9  Goto 0,0,0\n");
//  printf("12 Toggle Plane/Cyliner mode [%c]\n", mode);
  printf("19 Run now\n");
  printf("20 Quit\n");

  printf("\nok, gimme your chioce.. ");

  fflush(stdin);
  scanf("%s", &mchoice);
  i1 = atoi(mchoice);
  if (i1 == 20)
    return(-2);
  switch(i1) {

    case 1: // x offset
      printf("\nEnter X offset ");
      scanf("%s", &mchoice);
      if ((char)mchoice[0] != '\n')
        x_off = atof(mchoice);
    break;
    case 2: // y offset
      printf("\nEnter Y offset ");
      scanf("%s", &mchoice);
      if ((char)mchoice[0] != '\n')
        y_off = atof(mchoice);
    break;
    case 3: // z offset
      printf("\nEnter Z offset ");
      scanf("%s", &mchoice);
      if ((char)mchoice[0] != '\n')
        z_off = atof(mchoice);
    break;

    case 8: // goto xy offsets
        position(x_off, y_off, 0, stats);
    break;

    case 9: // goto 0,0
      zero('*','z', stats);
    break;
  /*
    case 12: // toggle plane mode
      if (mode == 'C')
       mode = 'P';
      else
       {
        mode = 'C';
        y_scale = 4800/height;
       }
    break;
   */
    case 19:  // end loop
       clrscr();
      // printf("    Size(inches): %.3lf X %.3lf X %.3lf\n",t1 ,t2 ,t3);
       ok = 1;
    break;

    default:  // yell and screem your lungs out
    break;    // oh well

    } // end of switch

}//end of while

 return 0;

} // end of function