#include <alloc.h>
#include <ctype.h>   // for the tolower fn
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <math.h>
#include <c:\prog\router\tio.c>   // router io functions


#define step_type 1
#define center 55000


typedef unsigned char	byte;
typedef unsigned int	word;
typedef unsigned long	dword;

// router routine tester

int main(int argc, char** argv)
{

  byte	id_length;
  byte	map_type;
  byte	image_type;
  word	first_entry;
  word	map_size;
  byte	entry_size;
  word	x_origin;
  word	y_origin;
  word	width;
  word	height;
  byte	bits_per_pixel;
  byte	descriptor;
  FILE* input;
  char*	id;
  unsigned char depth;
  long int x, y, z;
  dword file_pos;
  word error;
  long int stats[12];
  long int x_off, y_off, z_off;
  long int x_scale = 80, y_scale = 80, z_scale = 5;
  unsigned int skip = 450;
  double t1, t2, t3, t4;  //temp variables
  dword it1, it2;
  int i1, i2;
  byte ok = 0;
  char mchoice[20];
  char mode;

  ok = 0;
  mode = 'P';

  /****************************** initialize variables *********/

for (x=0; x<11; x++)
  stats[x] = 0;
  dremeloff();

  clrscr();

  if (argc < 5)                           // check input variables
  {

    puts("Syntax: readtga [file] x_offset y_offset z_offset [speed] ");
    return 0;

  }

 // puts("Please insert disk with datafile, and press enter");
 // while(!kbhit());

  if (argc > 2)
    x_off = atol(argv[2]);
  if (argc > 3)
    y_off = atol(argv[3]);
  if (argc > 4)
    z_off = atol(argv[4]);
  if (argc > 5)
    speed = atoi(argv[5]);
  if (argc > 6)
   {
    x_scale = atol(argv[6]);     // auto detect of bat stuff
    ok = 1;
   }
  if (argc > 7)
    y_scale = atol(argv[7]);
  if (argc > 8)
    z_scale = atol(argv[8]);
  if (argc > 9)
    x_scale = atoi(argv[9]);
  if (argc > 10)
    skip  = atoi(argv[10]);





  if ((input = fopen(argv[1], "rb")) == NULL)       //open tga file w err chk
  {
    printf("Unable to open %s for input.", argv[1]);
    return -1;
  }
  fread(&id_length, 1, 1, input);               //input file stuff
  fread(&map_type, 1, 1, input);
  if (map_type != 1)
  {
    puts("TrueColor too complicated for me...");
    fclose(input);
    return -1;
  }
  fread(&image_type, 1, 1, input);
  if ((image_type != 1))
  {
    puts("I won't put up with compressed files.");
    fclose(input);
    dremeloff();
    return -1;
  }
  fseek(input, 9, SEEK_CUR);
  fread(&width, 2, 1, input);
  fread(&height, 2, 1, input);
  if (width > 1000)
  {
    puts("Too wide, I wont play with it");
    dremeloff();
    return -1;
  }
  if (height > 2650)
  {
    puts("Too high, I wont play with it");
    dremeloff();
    return -1;
  }
  fread(&bits_per_pixel, 1, 1, input);
  if (bits_per_pixel != 8)
  {
    puts("Only 256 color images!");
    fclose(input);
    dremeloff();
    return -1;
  }
  fread(&descriptor, 1, 1, input);
  //printf("descriptor = %u", descriptor);

  if (id_length > 0)
  {
    fread(id, id_length, 1, input);   // !!!!!!!!!!!!! fixit!!
    puts(id);
  }
  fseek(input, 768, SEEK_CUR);
  file_pos = ftell(input);

  //--------------------------- menu thingy -------------------

//  ok = 0;
  while(!ok)
   {
  clrscr();
  printf("  image of %u X %u", width, height);
  gotoxy(1,3);
  t1 = ((double)width/(double)14400)*x_scale;
  t2 = ((double)height/(double)19200)*y_scale;
  t3 = ((double)255/(double)16000)*z_scale;
  printf("    MAX SIZE      11    X 5.5   X 16\n");
  printf("    Size(inches): %.3lf X %.3lf X %.3lf\n\n",t1 ,t2 ,t3);

  it1 = (((((width+x_off)*x_scale)*2)*(height*y_scale))* speed)/3600000;

  printf(" approx. time: %lu Hrs.\n", it1);

  printf("1  X Offset:      %ld\n", x_off);
  printf("2  Y Offset:      %ld\n", y_off);
  printf("3  Z Offset:      %ld\n", z_off);
  printf("4  X Scale:       %ld\n", x_scale);
  printf("5  Y Scale:       %ld\n", y_scale);
  printf("6  Z Scale:       %ld\n", z_scale);
  printf("7  Speed:         %d\n", speed);
  printf("8  Goto xy offsets\n");
  printf("9  Goto 0,0,0\n");
  printf("10 Y skip value   %d\n", skip);
  printf("11 Goto xymax\n");
  printf("12 Toggle Plane/Cyliner mode [%c]\n", mode);
  printf("19 Carve now\n");
  printf("20 Quit\n");

  printf("\nok, gimme your chioce.. ");

  fflush(stdin);
  scanf("%s", &mchoice);
  i1 = atoi(mchoice);
  if (i1 == 20)
    return(-2);
  switch(i1) {

    case 1: // x offset
      printf("\nEnter X offset ");
      scanf("%s", &mchoice);
      if ((char)mchoice[0] != '\n')
        x_off = atol(mchoice);
    break;
    case 2: // y offset
      printf("\nEnter Y offset ");
      scanf("%s", &mchoice);
      if ((char)mchoice[0] != '\n')
        y_off = atol(mchoice);
    break;
    case 3: // z offset
      printf("\nEnter Z offset ");
      scanf("%s", &mchoice);
      if ((char)mchoice[0] != '\n')
        z_off = atol(mchoice);
    break;
    case 4: // z scale
      printf("\nEnter X scale ");
      scanf("%s", &mchoice);
      if ((char)mchoice[0] != '\n')
        x_scale = atol(mchoice);
    break;
    case 5: // y scale
      printf("\nEnter Y scale ");
      scanf("%s", &mchoice);
      if ((char)mchoice[0] != '\n')
        y_scale = atol(mchoice);
    break;
    case 6: // z scale
      printf("\nEnter Z scale ");
      scanf("%s", &mchoice);
      if ((char)mchoice[0] != '\n')
        z_scale = atol(mchoice);
    break;

    case 7: // speed
      printf("\nEnter Speed ");
      scanf("%s", &mchoice);
      if ((char)mchoice[0] != '\n')
        speed = atol(mchoice);
    break;

    case 8: // goto xy offsets
      if (mode == 'P')
        position(x_off, y_off, 0, stats);
      else
        locate(x_off, center, 0, y_off, stats);
    break;

    case 9: // goto 0,0
      zero('*','z', stats);
      if (mode == 'C')
       zero('t','z',stats);
    break;

    case 10:  // set y skip
      printf("\nEnter Y skip value (max 30000) ");
      scanf("%s", &mchoice);
      if ((char)mchoice[0] != '\n')
        skip = atoi(mchoice);
    break;

    case 11: // goto xymax
      if (mode == 'P')
         position(x_off+(width*x_scale), y_off+(height*y_scale), 0, stats);
      else
         locate(x_off+(width*x_scale), center, 0, 0, stats);
    break;

    case 12: // toggle plane mode
      if (mode == 'C')
       mode = 'P';
      else
       {
        mode = 'C';
        y_scale = 4800/height;
       }
    break;

    case 19:  // end loop
       clrscr();
       printf("    Size(inches): %.3lf X %.3lf X %.3lf\n",t1 ,t2 ,t3);
       ok = 1;
    break;

    default:  // yell and screem your lungs out
    break;    // oh well

    } // end of switch

}//end of while


  setcmode('p');  // set the mode
  dremeloff();
  zero('*','z', stats);
  zero('*','z', stats);
  setcmode(tolower(mode));  // set the mode
  if (mode == 'C')   // if necc. zero axis and set y position
    {
    zero('t', 'z', stats);
    locate(stats[1], center, stats[5], stats[7], stats);
    }

  dremelon();

  //----------------------- now use collected data --------------

  error = 1;
  switch ((descriptor & 3) << 3)
  {
   case 0:

     while (error != 0)
     {
     error = 0;                           // loop till ok
     fseek(input, file_pos, SEEK_SET);    // start at the beggining
     t1 = 0;
     t2 = 0;
      for (y = 0; y < height; y++)        // run through data
      {
	for (x = 0; x < width; x++)
	{
	  fread(&depth, 1, 1, input);
          if (t1 > skip)
            {
              z = depth;
              gotoxy(9,9);
              printf ("Filesize: %d %d                 ",width, height);
	      gotoxy(10,10);
	      printf ("Filepos: %ld %ld %ld                ", x, y, z);
	      gotoxy(11,11);
	      printf("Routerpos: %ld %ld %ld                  ", (x*x_scale)+x_off, (y*y_scale)+y_off, (z*z_scale)+z_off);
              if (mode == 'P')     //If plane mode do in plane, if not do in clyindrical
                error = position((x*x_scale)+x_off, (y*y_scale)+y_off, (z*z_scale)+z_off, stats);
              else
                error = locate((x*x_scale)+x_off, stats[3], (z*z_scale)+z_off, (y*y_scale)+y_off, stats);
              t2 = 1;
            }
	}
      t1 += y_scale;
      if (t2 == 1)
       {
        t1 = 0;
        t2 = 0;
       }
      zero('z','z',stats);
      zero('z','z',stats);
      }
     }

     break;

    case 1:
	   puts("not able to handle condition 1 yet");
	   fclose(input);
           dremeloff();
	   return -1;
     // break;

    case 2:
	   puts("not able to handle condition 2 yet");
	   fclose(input);
           dremeloff();
      	   return -1;
   //   break;

    case 3:
	   puts("not able to handle condition 3 yet");
	   fclose(input);
           dremeloff();
	   return -1;
    //  break;

    default:

      printf("An impossible error occured, look for flying c0ws");
      fclose(input);
      dremeloff();
      return -2;

   }

  fclose(input);
  dremeloff();
  speed = 2;
  zero('z', 'z', stats);
  speed = 1;
  zero('*', 'z', stats);

  return 0;

}

