#include "dstuff.h"   //lp defs
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#define maxx 165600 //  11.5 inches
#define maxy 115200 //  6 inches
#define maxz 2147483646 // change this later
#define step_type 1
/*                      --------- TALK ----------
there are a set of universal variables here:

initialized from here:

xy   <-> lpt3
xy2  <-> lpt2

 these are to keep track of the last byte outputed to the ports so that
 operations preformed on different bits of a port are not destroyed
  between functions

 xmax
 ymax
 zmax

  these are intended to be a crash up protection, the maximums of the
  machine should be used... later...

  step_type

   this is used by the lowst level io routine for the motor sequince

   valid numbers are 1 and 2
    1 is the high resolution sequince [half stepping]
    2 is the power sequince, for added power... [not needed]
      anything else will cause random steps ["grgrgaaaoooaoaoggggrdrdrdr"]


 initialized from the main:

 long stats[10]   {** will be defined as long soon**}
   these are defined as follows:
     0   NOT USED
     1   last x position
     2   last x step number
     3   last y position
     4   last y step number
     5   last z position
     6   last z step number
     7   theta position
     8   theta step number
     9   ** reserved for start time hour
     10  ** reserved for stop time hour

   step numbers are from 0-7

  the speed variable is the delay in ms between steps of a single motor.

  for the zero routine
  {
   PLANE can be either 'x','y','z','*', or 't'
   x = zero x axis
   y = zero y axis
   z = zero z axis
   * = zero x,y,z axies (first z then x,y)
   t = zero rotary axis

   MORAL can be either 'r', or 'z'
   z = zero axis and leave at zero
   r = zero axis and return to pre-zero'd position
  }

  for the SETCMODE routine
  {
   mode can be either 'p', or 'c'
   c = cylindrical mode
   p = plane mode

   these are used when using the position routine to controll the
   rotary axis.
   can be avoided if u use the locate routine.

  }

  the position routine is now a dummy for backwards comatibility :-)

  the limitz and limitsw stuff is to speed up the inlimits function...
  thats it
  */


int speed;

int stepmotor(int type, char motor, long int last_out, long int dir);
int inlimits(void);

int locate (long int x, long int y, long int z, long int t, long int *stats);
int position (long int x, long int y, long int z, long int *stats);
int movx ( long int dir, long int *stats);
int movy ( long int dir, long int *stats);
int movz ( long int dir, long int *stats);
int movt ( long int dir, long int *stats);
int zero (char plane, char moral, long int *stats);

void dremeloff (void);
void dremelon (void);
void checktime (long int *stats);

void setcmode(char mode);

void relax();


  // -------------------- io routines ------------------



int xy, xy2;  // last outputed to port record


int stepmotor(int type, char motor, long int last_out, long int dir)
{
  long int out;
  int sequince[9];

  if ((last_out < 0) || (last_out > 7))     // error checking
    last_out = 0;

    if (type == 1)
      {
	sequince[0] = 1;      // step sequince data  type 1
	sequince[1] = 3;      // (accuracy)
	sequince[2] = 2;
	sequince[3] = 6;
	sequince[4] = 4;
	sequince[5] = 12;
	sequince[6] = 8;
	sequince[7] = 9;
      }
    if (type == 2)
      {
	sequince[0] = 5;      // step sequince data type 2
	sequince[1] = 9;      // (power)
	sequince[2] = 10;
	sequince[3] = 6;
	sequince[4] = 5;
	sequince[5] = 9;
	sequince[6] = 10;
	sequince[7] = 6;
      }

  // look up last output wrt table #

  if (dir == 0)      //dont step
    out = last_out;
  else
  if (dir > 0)          // go up table
    if (last_out == 7)
     out = 0;
    else
     out = ++last_out;
  else
  if (dir < 0)           // go down table
    if (last_out == 0)
     out = 7;
    else
     out = --last_out;

  // output to apropriot motor
  if (motor == 'x')
   {
   xy = xy & 240;          // touch only what need be
   xy = xy | sequince[out];
   }
  else
  if (motor == 'y')
   {
   xy = xy & 15;
   xy = xy | (sequince[out] << 4);
   }
  else
  if (motor == 'z')
   {
    xy2 = xy2 & 240;
    xy2 = xy2 | sequince[out];
   }
 outportb( lp3, xy);
 outportb( lp2, xy2);

return(out);
}




void relax() {

 outportb( lp3, 0);
 outportb( lp2, 16);
 return;


}




int inlimits()
{
  int output = 0;
  char c;

  c = inportb(lp3+1);
  if (!(c & 0x80))
    output = output | 1;  //x is zero
  if (c & 0x10)
    output = output | 2;    //y is zero
  if (c & 0x20)
    output = output | 4;    //z is zero
  if (!(c & 0x40))
    output = output | 8;    //theta is zero
  if (c & 0x08)
    output = output | 16;    //undedicated ..


return (output);
}

int locate (long int x, long int y, long int z, long int t, long int *stats)
{
 long int xx, yy, zz, tt, E, d;
 int error;
 int strtdly;
 unsigned int dly;

error = 0;
xx = labs(x - stats[1]);      // get offsets
yy = labs(y - stats[3]);
zz = labs(z - stats[5]);
tt = labs(t - stats[7]);

//checktime(stats);             // stop for the night if necissary

// ------------------- if last position lower ---------------------
if (stats[5] < z)
  {
  // move to position
  while ((xx > 0) || (yy > 0))  //for as long as it takes
   {
    // step x
    if (xx > 0)
      {
      if ((E = movx((x - stats[1]), stats)) != 0)  //error **
	{
	 error = E & 3;
	 xx = 0;  // exit loop
	 yy = 0;
	}
      xx--; // one less x steps
      }
    // step y
    if (yy > 0)
     {
     if ((E = movy((y - stats[3]), stats)) != 0)  //error    **
      {
	error = E & 3;
	xx = 0;  // exit loop
	yy = 0;
      }
     yy--;    //one less y
     }
     delay(speed);
     }
   // ***!!!***   set theta
    strtdly = 20;
    while (tt > 0)
    {
     if ((E = movt((t - stats[7]), stats)) != 0)  //error    **
      {
      // theta has no know errors it can cause
      }
     tt--;    //one less t
     if (strtdly != 1)
      strtdly--;
     delay(speed+ strtdly);
    }

   // set depth
   strtdly = 20;
   for (d=0; d < zz; d++)
    {
    if ((E = movz((z - stats[5]), stats)) != 0)
      {
	error= E & 3;
	d = labs(z - stats[5]);
      }
    if (strtdly != 1)
     strtdly--;
    delay(speed+ strtdly);
    }
  }   //close of if
  else   // ------------- (last position higher) ------------------
  {
  // set depth
   strtdly = 20;
   for (d=0; d < zz; d++)
    {
    if ((E = movz((z - stats[5]), stats)) != 0)
      {
	error = E & 3;
	d = labs(z - stats[5]);
      }
    if (strtdly != 1)
     strtdly--;
    delay(speed + strtdly);
    }

  // move to position
  while ((xx != 0) || (yy != 0))  //for as long as it takes
   {
    // step x
    if (xx != 0)
      {
      if ((E = movx((x - stats[1]  ), stats)) != 0)  //error **
	{
	 error = E & 3;
	 xx = 0;  // exit loop
	 yy = 0;
	}
      xx--;
      }
    // step y
    if (yy != 0)
     {
     if ((E = movy((y - stats[3]), stats)) != 0)  //error    **
      {
	error= E & 3;
	xx = 0;  // exit loop
	yy = 0;
      }
     yy--;
     }
     delay(speed);
   }
    // move theta
    strtdly = 20;
    while (tt > 0)
    {
     if ((E = movt((t - stats[7]), stats)) != 0)  //error    **
      {
      // theta has no know errors it can cause
      }
     tt--;    //one less t
     if (strtdly != 1)
      strtdly--;
     delay(speed+ strtdly);
    }
  }


// update position variables

 stats[1] = x;
 stats[3] = y;
 stats[5] = z;
 stats[7] = t;

 return (error);


}


int position (long int x, long int y, long int z, long int *stats)
{
 int error;
 error = 0;
 error = locate(x, y, z, stats[7], stats);
 return (error);
}



//------------- movx ----------         ...error checking routines...
int movx ( long int dir, long int *stats)
 {
  long int position;
  int error = 0;   // get table position (x)

  if (dir == 0)
   return(0);

    position = stats[1];    // compare to max. and forward requrest (dist > 0)
    if ((dir > 0) && (position > maxx))
      {     // if equal return error 1
      error = 1;
      }
    else       // compare to zero and reverse request (dist < 0)
      if ((dir < 0) && (position < 0))
	{       // if equal return error -1
	error = -1;
	}
      else
       {       // inc or dec as req'd
       setcmode('p');
       stats[2] = stepmotor (1, 'x', stats[2], dir);
       }
  return (error);
 }


 //-------- movy ------------------
int movy ( long int dir, long int *stats)
 {
  long  int position;
  int error = 0;

  if (dir == 0)
    return(0);

    // get table position (y)
    position = stats[3];  // compare to max. and forward requrest (dist > 0)
    if ((dir > 0) && (position == maxy))    // if equal return error 1
      error = 1;
    else      // compare to zero and reverse request (dist < 0)
      if ((dir < 0) && (position == 0))         // if equal return error -1
	error = -1;
      else
       {
       // inc or dec as req'd
       setcmode('p');
       stats[4] = stepmotor (step_type, 'y', stats[4], dir);
       }
  return (error);
 }

 //-------- movz ------------------
 int movz ( long int dir, long int *stats)
 {
  long int position ;
  int error = 0;

  if (dir == 0)
   return(0);

    // get table position (z)
    position = stats[5]; // compare to max. and forward requrest (dist > 0)
    if ((dir > 0) && (position == maxz))    // if equal return error 1
      error = 1;
    else      // compare to zero and reverse request (dist < 0)
      if ((dir < 0) && (position == 0))         // if equal return error -1
	error = -1;
      else
       {
       // inc or dec as req'd
       setcmode('p');
       stats[6] = stepmotor (step_type, 'z', stats[6], dir);
       }
  return (error);
 }

  //-------- movt ------------------
int movt ( long int dir, long int *stats)
 {
  long  int position;
  int error = 0;

  if (dir == 0)
    return(0);

    // get table position (y)
       // inc or dec as req'd
       setcmode('c');
       stats[8] = stepmotor (step_type, 'y', stats[8], dir);

  return (error);
 }

 //--------- zero ---------------- [x, y, z, t, or *][ r eturn, z ero]
 int zero (char plane, char moral, long int *stats)
 {
  long int status, a, b, c, d;
  int error, dc;
  char ok;
  int strtup;

  // bring cutter up
    strtup = 20;
    while (!(inlimits() & 4))
       {
	 stats[6] = stepmotor (step_type, 'z', stats[6], -1);  // move to zeroL
	 delay(speed + strtup);
	 if (strtup != 1)
	   strtup--;
       }
  //and back off till switch ack's
     strtup = 20;
     while ((inlimits() & 4))
       {
	 stats[6] = stepmotor (step_type, 'z', stats[6], 1);  // move to zeroH
	 delay(speed + strtup);
	 if (strtup != 1)
	  strtup--;
       }


  ok = 0;                  // move x and y to zeroL
  while (!ok)
  {
    ok = 1;   //untill nobody is using loop...
    if (((plane == 'x') || (plane == '*')) && !(inlimits() & 1))
      {
      // step x down
      stats[2] = stepmotor (step_type, 'x', stats[2], -1);
      ok = 0;
      }
    if (((plane == 'y') | (plane == '*')) && !(inlimits() & 2))
      {
      // step y down
      stats[4] = stepmotor (step_type, 'y', stats[4], -1);
      ok = 0;
      }
    if ((plane == 't') && !(inlimits() & 8))
      {
      // step t
      setcmode('c');    // make shure were working with the right motor
      stats[8] = stepmotor (step_type, 'y', stats[8], -1);
      ok = 0;
      }

     delay(speed);
  } // end of while

  ok = 0;                  // move x and y to zeroH
  while (!ok)
  {
    ok = 1;   //untill nobody is using loop...
    if (((plane == 'x') || (plane == '*')) && (inlimits() & 1))
      {
      // step x down
      stats[2] = stepmotor (step_type, 'x', stats[2], 1);
      ok = 0;
      }
    if (((plane == 'y') || (plane == '*')) && (inlimits() & 2))
      {
      // step y down
      stats[4] = stepmotor (step_type, 'y', stats[4], 1);
      ok = 0;
      }
    if ((plane == 't') && (inlimits() & 8))
      {
      // step t
      setcmode('c');    // make shure were working with the right motor
      stats[8] = stepmotor (step_type, 'y', stats[8], 1);
      ok = 0;
      }
     delay(speed);
  } // end of while


  // -- set back returns --
  a = stats[1];          // the old x pos.
  b = stats[3];
  c = stats[5];
  d = stats[7];

  stats[5] = 0;  // z always zero'd

if ((plane == 'x') || (plane == '*'))
  {
    if (moral == 'z')
     a = 0;                // kill if leaving at zero
    stats[1] = 0;          // erase old info, its obsolete
  }
if ((plane == 'y') || (plane == '*'))
  {
    if (moral == 'z')
     b = 0;
    stats[3] = 0;
  }
if ((moral == 'z') && (plane == 'z'))
   c = 0;
if (plane == 't')
  {
    stats[7] = 0;        // already zero'd at this point, put in books
    if (moral == 'r')    // if return then return
      {
      setcmode('c');
      locate(stats[1], stats[3], stats[5], d,  stats);   //***!!!*** change b to d
      }
  }
else
 {
  setcmode('p');
  error = position ( a, b, c, stats);
 }

  return (error);
 }



 void dremeloff(void)
  {
   xy2 = xy2 | 16;
   outportb(lp2, xy2);
   return;
  }

  void dremelon(void)
   {
    xy2 = xy2 & 239;  // !16
    outportb(lp2, xy2);
    return;
   }

  void checktime (long int *stats)
 {
  struct time t;
  stats[9] = 21;     // kill these later
  stats[10] = 8;

  gettime(&t);
  //gotoxy(5,20);
  //printf("Time: %2d:%02d:%02d\n", t.ti_hour, t.ti_min, t.ti_sec);
  if ((t.ti_hour > stats[9])||(t.ti_hour < stats[10]))       // shut down after 10:00
   {
   dremeloff();
   while (t.ti_hour != stats[10])
    {
    gotoxy(20,12);
    printf(" Time: %2d:%02d:%02d ", t.ti_hour, t.ti_min, t.ti_sec);
    gettime(&t);
    }
   dremelon();
   }

  return;
 }

 void setcmode(char mode)
   {
    if (mode == 'p')
     xy2 = xy2 & 223;    // ! 32
    else
     xy2 = xy2 | 32;
    outportb(lp2, xy2);
    return;
   }
